const dbConnection = require("../db/connection");

const fs = require("fs");

require("./globalfuntions.controller");

const { logger_data, logger_msg } = require('../config/utils');

global.__basedir = __dirname;

bodegas_sucursalesController = {};

arrayLog = [];

let msgLog = [];
let counter = 0;

bodegas_sucursalesController.bodegas_sucursales_loadpage = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
	res.send("API Bodegas / Sucursales");
};
//* Regresa la lista de Bodegas y Sucursales
bodegas_sucursalesController.bodegas_sucursales_list = (req, res) => {
	const data = req.body;
    console.table(data);
	const query = "SELECT id,descripcion,direccion,telefono, 2 as inventario FROM sucursales WHERE " + 
	"idEmpresas = ? UNION SELECT id,descripcion,direccion,telefono, 1 as inventario FROM bodegas WHERE idEmpresas = ?;";
	dbConnection.connectionDB.query(query,[data.idEmpresas,data.idEmpresas], (error, results, response) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length>0) {
			res.json(results);
            console.log(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

//*Insert bodega 
//! IdUsuarios hará referencia al usuario encargado de esa sucursalo o bodega, NO del usuario loggeado.
bodegas_sucursalesController.bodegas_sucursales_create_post_bodega = (req, res) => {
	const bodega = req.body;
    if (!bodega) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		if (!bodega.descripcion ||
			!bodega.direccion ||
			!bodega.telefono ||
			!bodega.idUsuarios ||
			!bodega.idEmpresas) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
            console.table(bodega);
            const query = "INSERT INTO bodegas (descripcion,direccion,telefono,idUsuarios,idEmpresas) values (?,?,?,?,?);";
            dbConnection.connectionDB.beginTransaction((err) => {
                if (err) {
                    console.error("TRANSACTION ERROR :>> ", err);
                } else {
                    dbConnection.connectionDB.query(
                        query,
                        [
							bodega.descripcion,
							bodega.direccion,
							bodega.telefono,
							bodega.idUsuarios,
							bodega.idEmpresas
                        ],
                        (error, response, result) => {
                            if (error) {
                                dbConnection.connectionDB.rollback(() => {
                                    console.log("QUERY > ROLLBACK ERROR INSERT bodega :>> ", error);
                                    const status = globalFunctions.statusMsg(0);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                });
                            } else if (response) {
                                dbConnection.connectionDB.commit((err) => {
                                    if (err) {
                                        dbConnection.connectionDB.rollback(() => {
                                            console.log(
                                                "COMMIT ERROR ROLLBACK INSERT bodega :>> ",
                                                err,
                                            );
                                        });
                                    } else {
                                        const status = globalFunctions.statusMsg(1);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    }
                                });
                            }
                        },
                    );
                }
            });
        }
    }
};
//* Insert sucursal
bodegas_sucursalesController.bodegas_sucursales_create_post_sucursal = (req, res) => {
	const sucursal = req.body;
    if (!sucursal) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		if (!sucursal.descripcion ||
			!sucursal.direccion ||
			!sucursal.telefono ||
			!sucursal.idNomenclatura ||
			!sucursal.idCentrosCosto ||
			!sucursal.idUsuarios ||
			!sucursal.idEmpresas) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
            console.table(sucursal);
            const query = "INSERT INTO sucursales (descripcion,direccion,telefono,idNomenclatura,idCentrosCosto,idUsuarios,idEmpresas) VALUES (?,?,?,?,?,?,?);";
            dbConnection.connectionDB.beginTransaction((err) => {
                if (err) {
                    console.error("TRANSACTION ERROR :>> ", err);
                } else {
                    dbConnection.connectionDB.query(
                        query,
                        [
							sucursal.descripcion,
							sucursal.direccion,
							sucursal.telefono,
							sucursal.idNomenclatura,
							sucursal.idCentrosCosto,
							sucursal.idUsuarios,
							sucursal.idEmpresas
                        ],
                        (error, response, result) => {
                            if (error) {
                                dbConnection.connectionDB.rollback(() => {
                                    console.log("QUERY > ROLLBACK ERROR INSERT sucursal :>> ", error);
                                    const status = globalFunctions.statusMsg(0);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                });
                            } else if (response) {
                                dbConnection.connectionDB.commit((err) => {
                                    if (err) {
                                        dbConnection.connectionDB.rollback(() => {
                                            console.log(
                                                "COMMIT ERROR ROLLBACK INSERT sucursal :>> ",
                                                err,
                                            );
                                        });
                                    } else {
                                        const status = globalFunctions.statusMsg(1);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    }
                                });
                            }
                        },
                    );
                }
            });
        }
    }
};
//* Consultar la informacion de la bodega o sucursal seleccionada
bodegas_sucursalesController.bodegas_sucursales_detail = (req, res) => {
	const data = req.body;
	console.table(data);
	if(data.inventario == 1){ //Bodega
		var query = "SELECT * FROM bodegas WHERE id = ? AND idEmpresas = ?;";
	}else{ //Sucursal
		var query = "SELECT * FROM sucursales WHERE id = ? AND idEmpresas = ?;";
	}
	dbConnection.connectionDB.query(query, [data.id,data.idEmpresas], (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}
//* Update para bodegas
bodegas_sucursalesController.bodegas_sucursales_update_post_bodegas = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		const query = "UPDATE bodegas SET descripcion = ?, direccion = ?, telefono = ?, idUsuarios = ? WHERE id = ? and idEmpresas = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						data.descripcion,
						data.direccion,
						data.telefono,
						data.idUsuarios,
						data.id,
						data.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE bodegas :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK UPDATE bodegas :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
				);
			}
		});
	}
}
//* Update para Sucursales
bodegas_sucursalesController.bodegas_sucursales_update_post_sucursales = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		const query = "UPDATE sucursales SET descripcion = ?, direccion = ?, telefono = ?, idUsuarios = ?, idNomenclatura = ?, idCentrosCosto = ? WHERE id = ? AND idEmpresas = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						data.descripcion,
						data.direccion,
						data.telefono,
						data.idUsuarios,
						data.idNomenclatura,
						data.idCentrosCosto,
						data.id,
						data.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE sucursales :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK UPDATE sucursales :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
				);
			}
		});
	}
}
//* Eliminar una bodega / sucursal
bodegas_sucursalesController.bodegas_sucursales_delete_post = (req, res) => {
	const data = req.body;
	if (!data) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(data);
		if(data.inventario == 1){ //Bodega
			var query = "DELETE FROM bodegas WHERE id = ? AND idEmpresas = ?;";
		}else{ //Sucursal
			var query = "DELETE FROM sucursales WHERE id = ? AND idEmpresas = ?;";
		}
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [data.id,data.idEmpresas],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' bodega / sucursal :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
                            /*
							console.log("QUERY RESULT :>> ");
							console.log(result);
                            */
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK 'DELETE' bodega / sucursal :>> ",
											err,
										);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						} else {
							const status = globalFunctions.statusMsg(4);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						}
					},
				);
			}
		});
	}
}

//! Maximos y Minimos, kardex, resume existencia
module.exports.bodegas_sucursalesController = bodegas_sucursalesController;
